
dy(at(_,_)).
dy(has(_,_)).
dy(emptyHand(_)).

belief(at(robot,backyard)).
belief(at(tray1,table1)).
belief(at(tray2,table2)).
belief(emptyHand(hand)).

action(goto(GoalPoint), [
   at(robot,StartPoint)
],[
   initiates(at(robot,GoalPoint)),
   terminates(at(robot,StartPoint))
]).

action(pickObjectByHand(Object,Hand), [
   emptyHand(Hand),
   at(Object,Place),
   at(robot,Place)
],[
   initiates(has(Hand,Object)),
   terminates(emptyHand(Hand)),
   terminates(at(Object,Place))
]).

action(placeObjectByHand(Object,Hand), [
   has(Hand,Object),
   at(robot,Place)
],[
   initiates(emptyHand(Hand)),
   initiates(at(Object,Place)),
   terminates(has(Hand,Object))
]).

action(say(_),[],[]).

htn(moveObjectTo(Object,Destination), [
   at(Object,Destination)
],[
   say('It is already there. ')
]).

htn(moveObjectTo(Object,Destination), [
   at(Object,CurrentPlace),
   at(robot,CurrentPlace),
   eval(not(Destination=CurrentPlace))
],[
   pickObjectByHand(Object,hand),
   goto(Destination),
   placeObjectByHand(Object,hand)
]).

htn(moveObjectTo(Object,Destination), [
   at(Object,ObjectPlace),
   at(robot,CurrentPlace),
   eval(not(ObjectPlace=Destination)),
   eval(not(ObjectPlace=CurrentPlace))
],[
   goto(ObjectPlace),
   pickObjectByHand(Object,hand),
   goto(Destination),
   placeObjectByHand(Object,hand)
]).

